﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using DataVirtualization;
using System.ComponentModel;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for Window3.xaml
    /// </summary>
    public partial class Window3 : Window, INotifyPropertyChanged
    {
        private DemoCustomerProvider customerProvider;

        public Window3()
        {
            InitializeComponent();
            this.DataContext = this;
        }

        protected int selectedCustomerID;
        public int SelectedCustomerID
        {
            get { return selectedCustomerID; }
            set
            {
                this.selectedCustomerID = value;
                this.OnPropertyChanged("SelectedCustomerID");
            }
        }

        protected AsyncVirtualizingCollection<Customer> customerList;
        public AsyncVirtualizingCollection<Customer> CustomerList
        {
            get { return customerList; }
            set
            {
                this.customerList = value;
                this.OnPropertyChanged("CustomerList");
            }
        }

        private void XamComboEditor_KeyUp(object sender, KeyEventArgs e)
        {
            customerProvider = new DemoCustomerProvider(40000 /*number of items*/, 2000 /*delay*/);
            CustomerList = new AsyncVirtualizingCollection<Customer>(customerProvider, 200 /*page size*/, 3000 /*timeout*/);
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }

        #endregion
    }
}
